import { SqlExpression } from '../sql';
import type { ContainsFilterPattern } from './pattern-contains';
import type { CustomFilterPattern } from './pattern-custom';
import type { NumberRangeFilterPattern } from './pattern-number-range';
import type { RegexpFilterPattern } from './pattern-regexp';
import type { TimeIntervalFilterPattern } from './pattern-time-interval';
import type { TimeRelativeFilterPattern } from './pattern-time-relative';
import type { ValuesFilterPattern } from './pattern-values';
export declare type FilterPattern = ValuesFilterPattern | ContainsFilterPattern | RegexpFilterPattern | TimeIntervalFilterPattern | TimeRelativeFilterPattern | NumberRangeFilterPattern | CustomFilterPattern;
export declare type FilterPatternType = FilterPattern['type'];
export declare const FILTER_PATTERN_TYPES: FilterPatternType[];
export declare function fitFilterPattern(ex: SqlExpression): FilterPattern;
export declare function filterPatternToExpression(pattern: FilterPattern): SqlExpression;
export declare function formatPatternWithoutNegation(pattern: FilterPattern): string;
export declare function changeFilterPatternType(pattern: FilterPattern, newType: FilterPatternType): FilterPattern;
export declare function patternTypeToName(type: FilterPatternType): string;
export declare function initPatternForColumn(columnName: string, columnType: string): FilterPattern;
//# sourceMappingURL=index.d.ts.map