import { QueryResult } from '../query-result/query-result';
import { SqlQuery, SqlTable } from '../sql';
export interface TableInfo {
    name: string;
}
export interface ColumnInfo {
    name: string;
    type: string;
}
export declare class Introspect {
    static getTableIntrospectionQuery(): string;
    static decodeTableIntrospectionResult(queryResult: QueryResult): TableInfo[];
    static getTableColumnIntrospectionQuery(thing: SqlTable | string): SqlQuery;
    static decodeTableColumnIntrospectionResult(queryResult: QueryResult): ColumnInfo[];
    static getQueryColumnIntrospectionQuery(query: SqlQuery): SqlQuery;
    static getQueryColumnSampleQuery(query: SqlQuery): SqlQuery;
    static decodeColumnTypesFromPlan(queryPlanResult: QueryResult): string[];
    static decodeQueryColumnIntrospectionResult(queryPlanResult: QueryResult, sampleRowResult?: QueryResult): ColumnInfo[];
    static decodeColumnIntrospectionResult(queryResult: QueryResult, sampleRowResult?: QueryResult): ColumnInfo[];
}
//# sourceMappingURL=introspect.d.ts.map