import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlExpression } from '../sql-expression';
import { SeparatedArray } from '../utils';
import { SqlWhenThenPart } from './sql-when-then-part';
export interface SqlCaseValue extends SqlBaseValue {
    caseExpression?: SqlExpression;
    whenThenParts: SeparatedArray<SqlWhenThenPart>;
    elseExpression?: SqlExpression;
}
export declare class SqlCase extends SqlExpression {
    static type: SqlTypeDesignator;
    static DEFAULT_CASE_KEYWORD: string;
    static DEFAULT_ELSE_KEYWORD: string;
    static DEFAULT_END_KEYWORD: string;
    static ifThenElse(conditionExpression: SqlExpression, thenExpression: SqlExpression, elseExpression?: SqlExpression): SqlCase;
    readonly caseExpression?: SqlExpression;
    readonly whenThenParts: SeparatedArray<SqlWhenThenPart>;
    readonly elseExpression?: SqlExpression;
    constructor(options: SqlCaseValue);
    valueOf(): SqlCaseValue;
    protected _toRawString(): string;
    changeCaseExpression(caseExpression: SqlExpression): this;
    changeWhenThenParts(whenThenParts: SeparatedArray<SqlWhenThenPart>): this;
    changeElseExpression(elseExpression: SqlExpression): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlExpression | undefined;
    clearOwnSeparators(): this;
}
//# sourceMappingURL=sql-case.d.ts.map