import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
import { SeparatedArray } from '../../utils';
import { SqlClause, SqlClauseValue } from '../sql-clause';
export interface SqlClusteredByClauseValue extends SqlClauseValue {
    expressions: SeparatedArray<SqlExpression>;
}
export declare class SqlClusteredByClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_CLUSTERED_BY_KEYWORD: string;
    static create(expressions: SeparatedArray<SqlExpression> | SqlExpression[]): SqlClusteredByClause;
    readonly expressions: SeparatedArray<SqlExpression>;
    constructor(options: SqlClusteredByClauseValue);
    valueOf(): SqlClusteredByClauseValue;
    protected _toRawString(): string;
    changeExpressions(expressions: SeparatedArray<SqlExpression> | SqlExpression[]): this;
    addExpression(expression: SqlExpression, where?: 'start' | 'end'): SqlClusteredByClause;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
    clearOwnSeparators(): this;
    toArray(): readonly SqlExpression[];
    shiftIndexes(aboveIndex: number): SqlClusteredByClause;
}
//# sourceMappingURL=sql-clustered-by-clause.d.ts.map