import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SeparatedArray } from '../../utils';
import { SqlClause, SqlClauseValue } from '../sql-clause';
import { SqlColumnDeclaration } from './sql-column-declaration';
export interface SqlExtendClauseValue extends SqlClauseValue {
    columnDeclarations: SeparatedArray<SqlColumnDeclaration>;
}
export declare class SqlExtendClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_EXTEND_KEYWORD: string;
    static create(columnDeclarations: readonly SqlColumnDeclaration[]): SqlExtendClause;
    readonly columnDeclarations: SeparatedArray<SqlColumnDeclaration>;
    constructor(options: SqlExtendClauseValue);
    valueOf(): SqlExtendClauseValue;
    protected _toRawString(): string;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
    changeColumnDeclarations(columnDeclarations: SeparatedArray<SqlColumnDeclaration> | readonly SqlColumnDeclaration[]): this;
}
//# sourceMappingURL=sql-extend-clause.d.ts.map