import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
import { SeparatedArray } from '../../utils';
import { SqlClause, SqlClauseValue } from '../sql-clause';
import { SqlJoinPart } from './sql-join-part';
export interface SqlFromClauseValue extends SqlClauseValue {
    expressions: SeparatedArray<SqlExpression>;
    joinParts?: SeparatedArray<SqlJoinPart>;
}
export declare class SqlFromClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_FROM_KEYWORD: string;
    static create(expressions: SeparatedArray<SqlExpression> | SqlExpression[]): SqlFromClause;
    readonly expressions: SeparatedArray<SqlExpression>;
    readonly joinParts?: SeparatedArray<SqlJoinPart>;
    constructor(options: SqlFromClauseValue);
    valueOf(): SqlFromClauseValue;
    protected _toRawString(): string;
    changeExpressions(expressions: SeparatedArray<SqlExpression> | SqlExpression[]): this;
    changeJoinParts(joinParts: SeparatedArray<SqlJoinPart> | SqlJoinPart[] | undefined): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
    clearOwnSeparators(): this;
    getFirstTableName(): string | undefined;
    getFirstSchema(): string | undefined;
    hasJoin(): boolean;
    getJoins(): readonly SqlJoinPart[];
    addJoin(join: SqlJoinPart): this;
    removeAllJoins(): this;
}
//# sourceMappingURL=sql-from-clause.d.ts.map