import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
import { SeparatedArray } from '../../utils';
import { SqlClause, SqlClauseValue } from '../sql-clause';
export declare type SqlGroupByDecorator = 'ROLLUP' | 'CUBE' | 'GROUPING SETS';
export interface SqlGroupByClauseValue extends SqlClauseValue {
    decorator?: SqlGroupByDecorator;
    innerParens?: boolean;
    expressions?: SeparatedArray<SqlExpression>;
}
export declare class SqlGroupByClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_GROUP_BY_KEYWORD: string;
    static create(expressions?: SeparatedArray<SqlExpression> | SqlExpression[]): SqlGroupByClause;
    readonly decorator?: SqlGroupByDecorator;
    readonly innerParens: boolean;
    readonly expressions?: SeparatedArray<SqlExpression>;
    constructor(options: SqlGroupByClauseValue);
    valueOf(): SqlGroupByClauseValue;
    protected _toRawString(): string;
    changeExpressions(expressions: SeparatedArray<SqlExpression> | SqlExpression[] | undefined): this;
    addExpression(expression: SqlExpression, where?: 'start' | 'end'): SqlGroupByClause;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
    clearOwnSeparators(): this;
    toArray(): readonly SqlExpression[];
    removeExpression(selectExpression: SqlExpression, selectIndex: number): SqlGroupByClause;
    shiftIndexes(aboveIndex: number): SqlGroupByClause;
}
//# sourceMappingURL=sql-group-by-clause.d.ts.map