import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlColumnList } from '../../sql-column-list/sql-column-list';
import { SqlTable } from '../../sql-table/sql-table';
import { SqlClause, SqlClauseValue } from '../sql-clause';
export interface SqlInsertClauseValue extends SqlClauseValue {
    table: SqlTable;
    columns?: SqlColumnList;
}
export declare class SqlInsertClause extends SqlClause {
    static type: SqlTypeDesignator;
    static readonly DEFAULT_INSERT_KEYWORD = "INSERT";
    static readonly DEFAULT_INTO_KEYWORD = "INTO";
    static create(table: SqlInsertClause | SqlTable | string): SqlInsertClause;
    readonly table: SqlTable;
    readonly columns?: SqlColumnList;
    constructor(options: SqlInsertClauseValue);
    valueOf(): SqlInsertClauseValue;
    protected _toRawString(): string;
    changeTable(table: SqlTable | string): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
}
//# sourceMappingURL=sql-insert-clause.d.ts.map