import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
import { SeparatedArray } from '../../utils';
import { SqlClause, SqlClauseValue } from '../sql-clause';
import { SqlOrderByExpression } from '../sql-order-by-expression/sql-order-by-expression';
export interface SqlOrderByClauseValue extends SqlClauseValue {
    expressions: SeparatedArray<SqlOrderByExpression>;
}
export declare class SqlOrderByClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_ORDER_BY_KEYWORD: string;
    static create(expressions: SeparatedArray<SqlOrderByExpression> | SqlOrderByExpression[] | SqlOrderByExpression): SqlOrderByClause;
    readonly expressions: SeparatedArray<SqlOrderByExpression>;
    constructor(options: SqlOrderByClauseValue);
    valueOf(): SqlOrderByClauseValue;
    protected _toRawString(): string;
    changeExpressions(expressions: SeparatedArray<SqlOrderByExpression> | SqlOrderByExpression[]): this;
    addExpression(expression: SqlOrderByExpression, where?: 'start' | 'end'): SqlOrderByClause;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
    clearOwnSeparators(): this;
    toArray(): readonly SqlOrderByExpression[];
    addFirst(orderBy: SqlOrderByExpression): SqlOrderByClause;
    removeExpression(selectExpression: SqlExpression, selectIndex: number): SqlOrderByClause | undefined;
    shiftIndexes(aboveIndex: number): SqlOrderByClause;
}
//# sourceMappingURL=sql-order-by-clause.d.ts.map