import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
import { SeparatedArray } from '../../utils';
import { SqlClause, SqlClauseValue } from '../sql-clause';
export interface SqlPartitionByClauseValue extends SqlClauseValue {
    expressions: SeparatedArray<SqlExpression>;
}
export declare class SqlPartitionByClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_PARTITION_BY_KEYWORD: string;
    static create(expressions: SeparatedArray<SqlExpression> | SqlExpression[]): SqlPartitionByClause;
    readonly expressions: SeparatedArray<SqlExpression>;
    constructor(options: SqlPartitionByClauseValue);
    valueOf(): SqlPartitionByClauseValue;
    protected _toRawString(): string;
    changeExpressions(expressions: SeparatedArray<SqlExpression> | SqlExpression[]): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
}
//# sourceMappingURL=sql-partition-by-clause.d.ts.map