import { SqlBase, SqlTypeDesignator, Substitutor } from '../../sql-base';
import { SqlExpression } from '../../sql-expression';
import { SqlClause, SqlClauseValue } from '../sql-clause';
export interface SqlWhereClauseValue extends SqlClauseValue {
    expression: SqlExpression;
}
export declare class SqlWhereClause extends SqlClause {
    static type: SqlTypeDesignator;
    static DEFAULT_WHERE_KEYWORD: string;
    static create(expression: SqlWhereClause | SqlExpression): SqlWhereClause;
    static createForFunction(expression: SqlWhereClause | SqlExpression): SqlWhereClause;
    readonly expression: SqlExpression;
    constructor(options: SqlWhereClauseValue);
    valueOf(): SqlWhereClauseValue;
    protected _toRawString(): string;
    changeExpression(expression: SqlExpression): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlClause | undefined;
    removeColumnFromAnd(column: string): SqlWhereClause | undefined;
}
//# sourceMappingURL=sql-where-clause.d.ts.map