import { SqlBaseValue, SqlTypeDesignator } from '../sql-base';
import { SqlExpression } from '../sql-expression';
import { SqlTable } from '../sql-table/sql-table';
import { RefName } from '../utils';
export interface SqlColumnValue extends SqlBaseValue {
    refName: RefName;
    table?: SqlTable;
}
export declare class SqlColumn extends SqlExpression {
    static type: SqlTypeDesignator;
    static create(name: string | SqlColumn, table?: SqlTable | string): SqlColumn;
    static optionalQuotes(name: string | SqlColumn, table?: SqlTable | string): SqlColumn;
    readonly refName: RefName;
    readonly table?: SqlTable;
    constructor(options: SqlColumnValue);
    valueOf(): SqlColumnValue;
    protected _toRawString(): string;
    changeRefName(refName: RefName): this;
    getName(): string;
    changeName(name: string): this;
    changeTable(table: SqlTable | undefined): this;
    getTableName(): string | undefined;
    changeTableName(table: string | undefined): this;
    getNamespaceName(): string | undefined;
    prettyTrim(maxLength: number): this;
    convertToTable(): SqlTable;
    getOutputName(): string;
}
//# sourceMappingURL=sql-column.d.ts.map