import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlExpression } from '../sql-expression';
import { SqlLiteral } from '../sql-literal/sql-literal';
export interface SqlLikePartValue extends SqlBaseValue {
    like: SqlExpression;
    escape: SqlExpression;
}
export declare class SqlLikePart extends SqlBase {
    static type: SqlTypeDesignator;
    static DEFAULT_ESCAPE_KEYWORD: string;
    static create(like: SqlExpression | string, escape: SqlExpression | string): SqlLikePart;
    readonly like: SqlExpression;
    readonly escape: SqlExpression;
    constructor(options: SqlLikePartValue);
    valueOf(): SqlLikePartValue;
    protected _toRawString(): string;
    changeLike(like: SqlLiteral): this;
    changeEscape(escape: SqlLiteral): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlBase | undefined;
}
//# sourceMappingURL=sql-like-part.d.ts.map