import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlExpression } from '../sql-expression';
import { RefName } from '../utils';
export interface SqlLabeledExpressionValue extends SqlBaseValue {
    label: RefName;
    expression: SqlExpression;
}
export declare class SqlLabeledExpression extends SqlExpression {
    static type: SqlTypeDesignator;
    static create(label: RefName | string, expression: SqlExpression, forceQuotes?: boolean): SqlLabeledExpression;
    readonly label: RefName;
    readonly expression: SqlExpression;
    constructor(options: SqlLabeledExpressionValue);
    valueOf(): SqlLabeledExpressionValue;
    protected _toRawString(): string;
    changeExpression(expression: SqlExpression): this;
    changeLabel(label: string | RefName, forceQuotes?: boolean): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlExpression | undefined;
    getLabelName(): string | undefined;
    getUnderlyingExpression(): SqlExpression;
}
//# sourceMappingURL=sql-labeled-expression.d.ts.map