import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { DecomposeViaAndOptions, SqlExpression } from '../sql-expression';
import { SeparatedArray } from '../utils';
export declare type SqlMultiOp = 'OR' | 'AND' | '||' | '+' | '-' | '*' | '/';
export interface SqlMultiValue extends SqlBaseValue {
    op: SqlMultiOp;
    args: SeparatedArray<SqlExpression>;
}
export declare class SqlMulti extends SqlExpression {
    static type: SqlTypeDesignator;
    readonly op: SqlMultiOp;
    readonly args: SeparatedArray<SqlExpression>;
    constructor(options: SqlMultiValue);
    valueOf(): SqlMultiValue;
    protected _toRawString(): string;
    numArgs(): number;
    getArgArray(): readonly SqlExpression[];
    getArg(index: number): SqlExpression | undefined;
    changeArgs(args: SeparatedArray<SqlExpression>): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlExpression | undefined;
    clearOwnSeparators(): this;
    and(expression: SqlExpression): SqlExpression;
    decomposeViaAnd(options?: DecomposeViaAndOptions): SqlExpression[];
    or(expression: SqlExpression): SqlExpression;
    filterAnd(fn: (ex: SqlExpression) => boolean): SqlExpression | undefined;
}
//# sourceMappingURL=sql-multi.d.ts.map