import { SqlBaseValue, SqlTypeDesignator } from '../sql-base';
import { SqlColumn } from '../sql-column/sql-column';
import { SqlExpression } from '../sql-expression';
import { SqlNamespace } from '../sql-namespace/sql-namespace';
import { SqlStar } from '../sql-star/sql-star';
import { RefName } from '../utils';
export interface SqlTableValue extends SqlBaseValue {
    refName: RefName;
    namespace?: SqlNamespace;
}
export declare class SqlTable extends SqlExpression {
    static type: SqlTypeDesignator;
    static create(name: string | SqlTable, namespace?: SqlNamespace | string): SqlTable;
    static optionalQuotes(name: string | SqlTable, namespace?: SqlNamespace | string): SqlTable;
    readonly refName: RefName;
    readonly namespace?: SqlNamespace;
    constructor(options: SqlTableValue);
    valueOf(): SqlTableValue;
    protected _toRawString(): string;
    changeRefName(refName: RefName): this;
    getName(): string;
    changeName(name: string): this;
    changeNamespace(namespace: SqlNamespace | undefined): this;
    getNamespaceName(): string | undefined;
    changeNamespaceName(namespace: string | undefined): this;
    prettyTrim(maxLength: number): this;
    convertToNamespace(): SqlNamespace;
    column(name: string): SqlColumn;
    columnWithOptionalQuotes(name: string): SqlColumn;
    star(): SqlStar;
}
//# sourceMappingURL=sql-table.d.ts.map