import { SqlBase, SqlBaseValue, SqlTypeDesignator, Substitutor } from '../sql-base';
import { SqlOrderByClause } from '../sql-clause';
import { SqlPartitionByClause } from '../sql-clause/sql-partition-by-clause/sql-partition-by-clause';
import { RefName } from '../utils';
export interface SqlWindowSpecValue extends SqlBaseValue {
    windowName?: RefName;
    orderByClause?: SqlOrderByClause;
    partitionByClause?: SqlPartitionByClause;
}
export declare class SqlWindowSpec extends SqlBase {
    static type: SqlTypeDesignator;
    readonly windowName?: RefName;
    readonly orderByClause?: SqlOrderByClause;
    readonly partitionByClause?: SqlPartitionByClause;
    constructor(options: SqlWindowSpecValue);
    valueOf(): SqlWindowSpecValue;
    protected _toRawString(): string;
    changeWindowName(windowName: RefName | string | undefined): this;
    changeOrderByClause(orderByClause: SqlOrderByClause | undefined): this;
    _walkInner(nextStack: SqlBase[], fn: Substitutor, postorder: boolean): SqlWindowSpec | undefined;
}
//# sourceMappingURL=sql-window-spec.d.ts.map