export interface RefNameValue {
    name: string;
    quotes: boolean;
}
export declare class RefName {
    static RESERVED_KEYWORDS: string[];
    static RESERVED_ALIASES: string[];
    static ALLOWED_FUNCTIONS: string[];
    static isReservedKeyword(k: string): boolean;
    static isReservedAlias(k: string): boolean;
    static isReservedFunctionName(k: string): boolean;
    static needsQuotes(name: string): boolean;
    static needsQuotesAlias(name: string): boolean;
    static needsQuotesFunctionName(name: string): boolean;
    static maybe(name: string | undefined, forceQuotes?: boolean): RefName | undefined;
    static create(name: string | RefName, forceQuotes?: boolean): RefName;
    static alias(name: string | RefName, forceQuotes?: boolean): RefName;
    static functionName(name: string | RefName, forceQuotes?: boolean): RefName;
    readonly name: string;
    readonly quotes: boolean;
    constructor(options: RefNameValue);
    valueOf(): RefNameValue;
    toString(): string;
    changeName(name: string): RefName;
    changeNameAsAlias(name: string): RefName;
    changeNameAsFunctionName(name: string): RefName;
    prettyTrim(maxLength: number): RefName;
}
//# sourceMappingURL=ref-name.d.ts.map