import { Separator } from '..';
export declare type SeparatorOrString = Separator | string;
export declare class SeparatedArray<T> {
    static fromArray<T>(xs: readonly T[] | SeparatedArray<T>, separator?: SeparatorOrString): SeparatedArray<T>;
    static fromSingleValue<T>(x: T): SeparatedArray<T>;
    static fromTwoValuesWithSeparator<T>(value0: T, separator: SeparatorOrString, value1: T): SeparatedArray<T>;
    readonly values: readonly T[];
    readonly separators: (SeparatorOrString | undefined)[];
    constructor(values: readonly T[], separators?: (SeparatorOrString | undefined)[]);
    toString(defaultSeparator?: SeparatorOrString): string;
    length(): number;
    get(index: number): T | undefined;
    first(): T;
    change(index: number, newValue: T): SeparatedArray<T>;
    map<U>(callbackfn: (value: T, index: number) => U): SeparatedArray<U>;
    filter(fn: (value: T, index: number) => any): SeparatedArray<T> | undefined;
    filterMap<U>(callbackfn: (value: T, index: number) => U | undefined): SeparatedArray<U> | undefined;
    remove(index: number): SeparatedArray<T> | undefined;
    insert(index: number, value: T): SeparatedArray<T>;
    prepend(value: T): SeparatedArray<T>;
    append(value: T): SeparatedArray<T>;
    clearSeparators(): SeparatedArray<T>;
    clearSeparatorsMatching(match: string): SeparatedArray<T>;
}
//# sourceMappingURL=separated-array.d.ts.map